﻿<?php
define("VALID_CMS", 1);
define('PATH', $_SERVER['DOCUMENT_ROOT']);
include(PATH.'/core/cms.php');
include(PATH.'/core/classes/config.class.php');

$inConf = cmsConfig::getInstance();
$inCore = cmsCore::getInstance();
$inDB   = cmsDatabase::getInstance();
$inCore->loadClass('user');

$method 	= $inCore->request('method', 'str', '');
$uids	 	= $inCore->request('uids', 'str', '');
$uid 		= $inCore->request('uid', 'str', '')?$inCore->request('uid', 'str', ''):$inCore->request('user_id', 'str', '');
$user_id    = $inCore->request('user_id', 'str', '');
$token		= $inCore->request('token', 'str', '')?$inCore->request('token', 'str', ''):$inCore->request('access_token', 'str', '');
$apiid		= $inCore->request('api_id', 'str', '');
$method		= $inCore->request('method', 'str', '');
$image		= $inCore->request('app_img', 'str', '');
$name		= $inCore->request('app_name', 'str', '');
$message	= $inCore->request('message', 'str', '');

if (!$uid || !$token){
     echo "{'error': 'Неверные параметры запроса'}";
     exit();
}
$result = $inDB->query("SELECT * FROM " . $inConf->db_prefix.'_'. "wtmodule");
if(!$inDB->num_rows($result)) {
    echo "{'error': 'Не задан секретный ключ площадки'}";
    exit();
}
while ( $row = $inDB->fetch_assoc($result) ) {
	$$row['params'] = $row['val'];
}
if((!$method and md5($uid.$wt_skey)!=$token) or ($method and md5($apiid.$user_id.$wt_skey)!=$token)){
    echo "{'error': 'Неверный токен запроса'}";
    exit();
}
if ($method == 'getAppFriends'){// получаем друзей пользователя
	$inUser = cmsUser::getInstance();
	$response = '<?xml version="1.0" encoding="UTF-8"?><response>';
	$friends = @$inUser->getFriends($uid);
	foreach($friends as $key=>$value){
		$response .= '<uid>'.$value['id'].'</uid>';
	}
	$response .= '</response>';
}
else if ($method == 'getProfiles'){//получаем профили по уидс
	$users = explode(',', $uids);
	$response = '<?xml version="1.0" encoding="UTF-8"?><response>';
	foreach($users as $value ){
		$user = $value;
		$sql    = "SELECT u.nickname as nickname, u.login as login, u.birthdate as birthdate, p.gender as gender, p.imageurl as imageurl FROM ".$inConf->db_prefix."_users u LEFT JOIN ".$inConf->db_prefix."_user_profiles p ON p.user_id = u.id WHERE u.id=".$user." AND u.is_deleted = 0 AND u.is_locked = 0 LIMIT 1";
		$result = $inDB->query($sql);
		if(!$inDB->num_rows($result)) {
			echo "{'error': 'Пользователь не найден'}";
			exit();
		}
		$row   = $inDB->fetch_assoc($result);
		$response .='<user><uid>'.$user.'</uid>';
		$realname = explode(' ', trim($row['nickname']));
		if(count($realname)!==2){
			$response .= '<first_name>'.$row['nickname'].'</first_name>';
		}else{
			$response .= '<first_name>'.$realname[0].'<first_name></last_name>'.$realname[1].'</last_name>';
		}
		$sex = 0;
		if($row['gender']){
			if($row['gender'] == 'm') $sex = 2;
			else $sex = 1;
		}
		$photo = $row['imageurl']?'http://'.$_SERVER['SERVER_NAME'].'/images/users/avatars/'.$row['imageurl'].'':'';
		$response .='<photo>'.$photo.'</photo><photo_big>'.$photo.'</photo_big><sex>'.$sex.'</sex><bdate>'.$row['birthdate'].'</bdate><profile>http://'.$_SERVER['SERVER_NAME'].'/users/'.$row['login'].'</profile></user>';
	}
	$response .='</response>';
}
else if($method == 'wallPost'){
	$result = $inDB->query("SELECT id FROM ". $inConf->db_prefix."_modules WHERE content='mod_webtomat'");
	while ( $row = $inDB->fetch_assoc($result) ) {
		$mod_id = $row['id'];
	}
	if (!$mod_id) return false;
	$result = $inDB->query("SELECT menu_id FROM ". $inConf->db_prefix."_modules_bind WHERE module_id=".$mod_id);
	while ( $row = $inDB->fetch_assoc($result) ) {
		$menu_id = $row['menu_id'];
	}
	$result = $inDB->query("SELECT link FROM ". $inConf->db_prefix."_menu WHERE id=".$menu_id);
	while ( $row = $inDB->fetch_assoc($result) ) {
		$link = $row['link'];
	}
	
	require_once 'wt_message.php';
	$link = $link !=-1 ? $link : '';
	$link .= ($wt_load != 'AJAX') ? '?ingame='.$apiid : '#gameid='.$apiid;
	$link ='http://'.$_SERVER['HTTP_HOST'].$link;
	$block_img = $image ? str_replace('{img}', $image, $block_img) : '';
	$letter = str_replace('{block_img}', $block_img, $letter);
	$letter = str_replace('{link}', $link, $letter);
	$letter = str_replace('{name_link}', $name, $letter);
    $letter = str_replace('{text}', $message, $letter);
	if(!$inDB->get_field($inConf->db_prefix.'_users', "id= {$user_id}", 'id') || !$inDB->get_field($inConf->db_prefix.'_users', "id= {$uid}", 'id')) {
        echo "{'error': 'Пользователь не найден'}";
        exit();
    }
	
    $sql = "INSERT INTO ".$inConf->db_prefix."_user_wall (user_id, author_id, pubdate, content, usertype)
                        VALUES ('$uid', '$user_id', NOW(), '$letter', 'users')";
    $inDB->query($sql);
    
	echo '<wallPost>'.$letter.'</wallPost>';
}
else{//профиль юзера
	$sql    = "SELECT u.nickname as nickname, u.birthdate as birthdate, u.login as login, p.gender as gender, p.imageurl as imageurl FROM ".$inConf->db_prefix."_users u LEFT JOIN ".$inConf->db_prefix."_user_profiles p ON p.user_id = u.id WHERE u.id=".$uid." AND u.is_deleted = 0 AND u.is_locked = 0 LIMIT 1";
	$result = $inDB->query($sql);
	if(!$inDB->num_rows($result)) {
		echo "{'error': 'Пользователь не найден'}";
		exit();
	}
	$row   = $inDB->fetch_assoc($result);
	$realname = explode(' ', trim($row['nickname']));
	if(count($realname)!==2){
		$resp_name = '"first_name":"'.$row['nickname'].'",';
	}else{
		$resp_name = '"first_name":"'.$realname[0].'","last_name":"'.$realname[1].'",';
	}
	$sex = 0;
	if($row['gender']){
		if($row['gender'] == 'm') $sex = 2;
		else $sex = 1;
	}
	$photo = $row['imageurl']?'http://'.$_SERVER['SERVER_NAME'].'/images/users/avatars/'.$row['imageurl'].'':'http://static.apitech.ru/webtomat/jslib2/images/defaultPhoto.jpg';
	$response ='{'.$resp_name.'"uid":"'.$uid.'","photo":"'.$photo.'","photo_big":"'.$photo.'","sex":"'.$sex.'","bdate":"'.$row['birthdate'].'","profile":"http://'.$_SERVER['SERVER_NAME'].'/users/'.$row['login'].'"}';
}
if($response){
	echo $response;
} 

?>
