﻿<?php
/*
Plugin Name: WebTomat
Plugin URI: http://webtomat.com
Description: WebTomat - каталог мини игр на Вашем сайте
Version: 1.0

Copyright 2012 (email: team@webtomat.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
function mod_webtomat($module_id){
    global $wt_lang,$wt_webid,$wt_load,$wt_theme,$wt_last_update,$wt_version,$wt_window,$wt_logo,$wt_cache;

    require_once "admin/modules/mod_webtomat/wt_conf.php";
	require_once "wt_class.php";    //основная часть модуля, обработка .tpl
    Wt::construct();
	$wt = new Wt();
	/* рассчитываем корневую директорию (требуется, если сайт лежит не в корне) */
	$wt_root_dir = explode('/',$_SERVER['PHP_SELF']);
	array_pop($wt_root_dir);
	$wt_root_dir = implode('/',$wt_root_dir).'/';

    define ( 'WEBTOMAT_DIR', 'modules/mod_webtomat' );
    /* Проверяем, указан ли в настройках webID, если нет - выводим ошибку */
    if ( !isset($wt_webid) or empty($wt_webid) ) {
        $webtomat_container = '<div style="width:200px;height:20px;margin:100px auto;font-weight:bold;color:red">'.WebTomat_Data::$lang['wt_no_installed'].'.</div>';
    }
    else if (isset($wt_load) and $wt_load=='AJAX') {
		$escaped_fragment = Wt::globper('_escaped_fragment_');
	    if (isset($escaped_fragment)){
            $request = preg_split("/_/",$escaped_fragment);
			if (isset($request[2])) $request[1] = substr($escaped_fragment,strpos($escaped_fragment,'_')+1);
			if ($wt_version == '2'){//индексация 2ой версии
				global $wt_link;
				$wt_link = '?do=games';
				if ($request[0] == 'gameid'){
					$_REQUEST['ingame']=$request[1];
					$wt_game = file_get_contents( WEBTOMAT_DIR .'/themes/gamebrd/wt_game.tpl');
					if ( WEBTOMAT_DECODE == "windows-1251" ) {
						$wt_game = iconv( "UTF-8", "windows-1251", $wt_game );
					}
					$wt_cont = Wt::wt_ingame2($wt_game,$request[1],'#!genre_');
				}
				else{
					$wt_board = file_get_contents( WEBTOMAT_DIR .'/themes/gamebrd/wt_board.tpl');
					if ( WEBTOMAT_DECODE == "windows-1251" ) {
						$wt_board = iconv( "UTF-8", "windows-1251", $wt_board );
					}
					if ($request[0] == 'genre') 
						$wt_cont = Wt::wt_gameboard($wt_board,$request[1],'#!gameid_','#!genre_');
					else 
						$wt_cont = Wt::wt_gameboard($wt_board,null,'#!gameid_','#!genre_');
				}
            
			}
			else {//индексация 1ой версии
				if ($request[0] == 'gameid'){
					$_REQUEST['ingame']=$request[1];
					$ingame = $request[1];
					$wt_cont = file_get_contents( WEBTOMAT_DIR .'/themes/default/wt_ingame.tpl');
					if ( WEBTOMAT_DECODE == "windows-1251" ) {
						$wt_cont = iconv( "UTF-8", "windows-1251", $wt_cont );
					}
					$wt_cont = $wt->wt_ingame($wt_cont,$ingame);
				}
				else {
					if ($request[0] == 'genre' || $request[0] == 'cat' || $request[0] == 'tag'){//жанр
						$wt_cont = file_get_contents( WEBTOMAT_DIR .'/themes/default/wt_list.tpl');
						if ( WEBTOMAT_DECODE == "windows-1251" ) {
							$wt_cont = iconv( "UTF-8", "windows-1251", $wt_cont );
						}
						if ($request[0] == 'genre') $_REQUEST['ingenre'] = $request[1];
						else if ($request[0] == 'cat') $_REQUEST['cat'] = $request[1];
						else if ($request[0] == 'tag') $_REQUEST['intag'] = $request[1];
					}
					else {//главная страница каталога
						if ($request[0] == 'a' && isset($request[1]) && $request[1] == 'tags') {
							$_REQUEST['a'] = 'tags';
						}
						$wt_cont = file_get_contents( WEBTOMAT_DIR .'/themes/default/wt_main.tpl');
						if ( WEBTOMAT_DECODE == "windows-1251" ) {
							$wt_cont = iconv( "UTF-8", "windows-1251", $wt_cont );
						}
						$a = ($_REQUEST['a']) ? $_REQUEST['a'] : 'main';
						if (strpos ( $wt_cont, "[page=".$a ) !== false) {
							$_REQUEST['a']='main';
							$wt_cont = preg_replace ( "#\\[page=".$a."\\](.*?)\\[/page\\]#ies", "\$wt->".$a."('\\1')", $wt_cont );
							$wt_cont = preg_replace ( "#\\[page=(.*?)\\](.*?)\\[/page\\]#ies", "", $wt_cont );
						}
					}	
				}
				if (strpos ( $wt_cont, "[cont=" ) !== false) $wt_cont = preg_replace ( "#\\[cont=(.*?)\\](.*?)\\[/cont\\]#ies", "\$wt->\\1('\\2')", $wt_cont );
			}
			/* Производим замену переменных в шаблоне */
				$wt_link = ($_SERVER['REDIRECT_URL']) ? $_SERVER['SERVER_NAME'].$_SERVER['REDIRECT_URL'] : $_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF'].'?do=games';
				$wt_link = ($_SERVER['HTTPS']) ? 'https://'.$wt_link : 'http://'.$wt_link;
				$end_link = (strpos('?',$wt_link) != false) ? '&a=main' : '';
				$find = array('&ingame=','&ingenre=','&cat=','&intag=','&a=tags','{WTDIR}','{WTURLMAIN}','{WTMAIN}');
				$replace = array('#!gameid_','#!genre_','#!cat_','#!tag_','#!a_tags',$wt_root_dir.WEBTOMAT_DIR .'/',$wt_link,$wt_link);
				$wt_cont = str_replace($find,$replace,$wt_cont);
				$find = array('?ingame=','?ingenre=','?cat=','?intag=','?a=tags','{WTDIR}','{WTURLMAIN}','{WTMAIN}');
				$wt_cont = str_replace($find,$replace,$wt_cont);
				$wt_cont = str_replace('{WT_LOGIN}','',$wt_cont);
			
        }
        else {
        	$wt_cont = file_get_contents( WEBTOMAT_DIR.'/js-catalog.php' );
			$wt_cont = str_replace('{RAND}',mt_rand(),$wt_cont);
			$wt_cont = str_replace('{WEBID}',$wt_webid,$wt_cont);
			$wt_cont = str_replace('{MAINPAGE}',$wt_mainpage,$wt_cont);
			$wt_cont = str_replace('{VERSION}',$wt_version,$wt_cont);
			$wt_cont = str_replace('{wt_theme}',$wt_theme,$wt_cont);
			$buf='';
			if ($wt_window) $buf="&window=popup";
			if ($wt_skey) $buf.="&auth=1";
			if ($wt_mainpage) $buf.="&mainpage=".$wt_mainpage;
			if ($wt_theme) $buf.="&background=".$wt_theme;
			if ($wt_logo) $buf.="&nologo=1";
			if ($wt_cache) $buf.="&nocache=true";
			$wt_cont = str_replace('{params}',$buf,$wt_cont);
		}

        $webtomat_container = $wt_cont;

    } else {
        /* обработка данных, полученных через $_REQUEST и создание соответствующих переменных */
        $a          = Wt::globper('a');
        $ingenre    = Wt::globper('ingenre');
        $intag      = Wt::globper('intag');
        $ingame     = Wt::globper('ingame');
        $cat        = Wt::globper('cat');
        $search     = Wt::globper('search');
        $p          = Wt::globper('p');
        $rate       = Wt::globper('rate');
        $wt_ajax    = Wt::globper('ajax');
        $wt_id      = Wt::globper('wt_id');
        $wtid       = Wt::globper('wtid');
		
        if (!isset($ingenre) and !isset($intag) and !isset($ingame) and !isset($search) and !isset($cat) and !isset($a)){
            $a = 'main'; $_REQUEST['a'] = 'main'; }

        if ( isset($wt_ajax) and isset($wtid) ){	//принимаем AJAX с id пользователя и передаем его на запись в сессию

            exit('|WT_SPLIT|'.Wt::wt_sessWtId($wtid));

        }
        elseif ( isset($rate) and isset($ingame) ) {	//принимаем AJAX с голосом и id игры, передаем на проверку и запись в БД

            exit('|WT_SPLIT|'.Wt::wt_rate($rate,$ingame,$wt_id));

        }
        elseif ( isset( $a ) ) {	//обработка главной страницы и страницы "все теги"
            $wt_cont = file_get_contents( WEBTOMAT_DIR .'/themes/default/wt_main.tpl');
            if ( WEBTOMAT_DECODE == "windows-1251" ) {
                $wt_cont = iconv( "UTF-8", "windows-1251", $wt_cont );
            }

            if (strpos ( $wt_cont, "[page=".$a ) !== false) {
                $wt_cont = preg_replace ( "#\\[page=".$a."\\](.*?)\\[/page\\]#ies", "wt::".$a."('\\1')", $wt_cont );
                $wt_cont = preg_replace ( "#\\[page=(.*?)\\](.*?)\\[/page\\]#ies", "", $wt_cont );
            }


        } elseif ( isset( $ingame ) ) {		//обработка страницы с игрой

            $ingame = WebTomat_Data::wt_safesql( Wt::globper('ingame') );
            $wt_cont = file_get_contents( WEBTOMAT_DIR .'/themes/default/wt_ingame.tpl');
            if ( WEBTOMAT_DECODE == "windows-1251" ) {
                $wt_cont = iconv( "UTF-8", "windows-1251", $wt_cont );
            }

            $wt_cont = Wt::wt_ingame($wt_cont,$ingame);

        } elseif ( isset( $ingenre ) or isset( $cat ) or isset( $search ) or isset( $p ) or isset( $intag ) ) {		//обработка страниц с выводом спика игр

            $wt_cont = file_get_contents( WEBTOMAT_DIR .'/themes/default/wt_list.tpl');
            if ( WEBTOMAT_DECODE == "windows-1251" ) {
                $wt_cont = iconv( "UTF-8", "windows-1251", $wt_cont );
            }

            if ( isset($wt_ajax) ) {		//если запрос пришел через AJAX, готовим на вывод только список игр.

                if (strpos ( $wt_cont, "[cont=wt_gameblock]" ) !== false)
                    preg_match("#\\[cont=wt_gameblock\\](.*?)\\[/cont\\]#ies", $wt_cont, $matches);
                $wt_cont = Wt::wt_gameblock($matches[1]);

            }
        }

        if (strpos ( $wt_cont, "[cont=" ) !== false)
            $wt_cont = preg_replace ( "#\\[cont=(.*?)\\](.*?)\\[/cont\\]#ies", "wt::\\1('\\2')", $wt_cont );

        /* Производим замену переменных в шаблоне */
		if (!$wt_skey) $wt_cont = str_replace('{WT_LOGIN}',file_get_contents( WEBTOMAT_DIR .'/themes/default/wt_login.tpl'),$wt_cont);
        $find = array(
            '{WTDIR}','{WTURLMAIN}','{WTURLCALL}'
        );
		
        $replace = array(
            '/'.WEBTOMAT_DIR .'/','?do=games',urlencode("http://".$_SERVER['SERVER_NAME'].$wt_root_dir.WEBTOMAT_DIR.'/ulogin_xd.html')
        );

        $wt_cont = str_replace($find,$replace,$wt_cont);

        /* Если запрос пришел GET-методом - отдаем контент CMS, если AJAX - прекращаем работу скрипта и отвечаем клиенту */
        if ( isset($wt_ajax) ){
			header("Content-Type: text/html; charset=utf-8");
            if ( WEBTOMAT_DECODE == "windows-1251" ) {
                $wt_cont = iconv( "windows-1251", "UTF-8", $wt_cont );
            }
            exit($wt_cont);
        }
        else
            $webtomat_container = $wt_cont;
			
		

    }
	$auth = '';
	if ($wt_skey){/* авторизация через cms */
		$inUser = cmsUser::getInstance();
		$auth = file_get_contents( WEBTOMAT_DIR.'/js-auth.php' );
		$auth = str_replace('{webid}',$wt_webid,$auth);
		if ($inUser) {
			$auth = str_replace('{uid}',$inUser->id,$auth);
			$auth = str_replace('{token}',"'".md5($inUser->id.$wt_skey)."'",$auth);
		}
		$auth = str_replace('{uid}','null',$auth);
		$auth = str_replace('{token}','null',$auth);
		if ($wt_load == 'AJAX'){
			$auth = str_replace('{fready_begin}','window.wt_tomatReady = function(){',$auth);
			$auth = str_replace('{fready_end}','}',$auth);
			$auth = str_replace('{script}','',$auth);
		}
		else {
			$auth = str_replace('{fready_begin}','',$auth);
			$auth = str_replace('{fready_end}','',$auth);
			$auth = str_replace('{script}','<script id="wt_custom_api" type="text/javascript" src="http://static.apitech.ru/webtomat/api/api.js"> </script>',$auth);
		}
		$auth = str_replace('{login_location}',$wt_root_dir.'login',$auth);
		$webtomat_container = str_replace('{WT_LOGIN}','',$webtomat_container);
	}/**/
	$webtomat_container=$auth.$webtomat_container;
// передаем в шаблон переменные

	
    $smarty = cmsCore::getInstance()->initSmarty('modules', 'mod_webtomat.tpl');
    $smarty->assign('WEBTOMAT_CONTAINER'	, $webtomat_container);
    $smarty->display('mod_webtomat.tpl');
	
	return true;
}

?>