<?php

global $db,$table_prefix,$inConf;
$db = cmsDatabase::getInstance(); // подключаем базу

$PHP_SELF = $_SERVER['PHP_SELF'];

define ( 'WEBTOMAT_PREF', $inConf->db_prefix.'_');
define ( 'WEBTOMAT_DIR', 'modules/mod_webtomat' );

$arr_themes = scandir( WEBTOMAT_DIR . '/themes/' ); array_splice($arr_themes,0,2);

if ( 0 ) {
	define ( 'WEBTOMAT_DECODE', "windows-1251" );
} else {
	define ( 'WEBTOMAT_DECODE', "UTF-8" );
}

class WebTomat_Data {

    static public $lang = array();
    static public $data = array();
    static public $themes = array();
    static public $wt_query = 0;
    static public $wt_result = array();

    public function __construct(){
        global $wt_lang;
        require 'webtomat.lng';
        if ( WEBTOMAT_DECODE == "windows-1251" ) {
            foreach($wt_lang as $key => $val){
                $wt_lang[$key] = iconv('UTF-8','windows-1251//IGNORE',$val);
            }
        }
        self::$lang = $wt_lang;

        $arr_themes = scandir( WEBTOMAT_DIR . '/themes/' ); array_splice($arr_themes,0,2);
        self::$themes = $arr_themes;
    }

    static public function wt_mysql($query) // метод запросов к базе
    {
        global $db;
        if (!empty($query))
            $wt_query = $db->query($query);

        return $wt_query;
    }

    static public function wt_getrow($id = false) // метод получения массива из результата запроса
    {
        global $db;
        $result = $db-> fetch_assoc($id);

        if (isset($result)) return $result;
		
    }

    static public function wt_numrow($z = 0) // метод получения количества строк из результата запроса
    {
        global $db;

		return $db->num_rows($z);
    }

    static public function wt_safesql($z) // метод обработки переменных перед подстановкой в запрос
    {
        global $db;
        $z = $db->escape_string($z);

        return $z;
    }

}
$data = new WebTomat_Data();

//таблица с настройками модуля
$data->wt_mysql("CREATE TABLE IF NOT
	 EXISTS " . WEBTOMAT_PREF . "wtmodule (
		`params` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
		`val` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
		PRIMARY KEY (`params`)
		)
		DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci
		;");

//таблица со списком игр
$data->wt_mysql("CREATE TABLE IF NOT EXISTS " . WEBTOMAT_PREF . "wtgames (
		`id` int(6) unsigned NOT NULL AUTO_INCREMENT,
		`wtg_id` int(6) unsigned NOT NULL,
		`wtg_title` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
		`wtg_name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
		`wtg_desc` text(0) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
		`wtg_height` int(4) unsigned NOT NULL,
		`wtg_width` int(4) unsigned NOT NULL,
		`wtg_tags` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
		`wtg_genres` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
		`wtg_apppath` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
		`wtg_popular` float(7,2) unsigned NOT NULL,
		`wtg_votes` int(6) NOT NULL DEFAULT 1,
		`wtg_new` int(4) unsigned NOT NULL,
		`wtg_created` int(15) unsigned NOT NULL,
		`wtg_img16` varchar(5) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
		`wtg_img50` varchar(5) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
		`wtg_img75` varchar(5) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
		`wtg_img100` varchar(5) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
		`wtg_img120` varchar(5) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
		`wtg_img200` varchar(5) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
		PRIMARY KEY (`id`)
		)
		DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci
		;");

//таблица с именами тегов и жанров
$data->wt_mysql("CREATE TABLE IF NOT EXISTS " . WEBTOMAT_PREF . "wtnames (
		`id` int(6) unsigned NOT NULL AUTO_INCREMENT,
		`en_name`  varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
		`rus_name`  varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
		`type`  varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
        `in_count` int(6),
		PRIMARY KEY (`id`)
		)
		DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci
		;");

//таблица с привязанными к ID пользователей списками игр ( за которые голосовал пользователь )
$data->wt_mysql("CREATE TABLE IF NOT EXISTS " . WEBTOMAT_PREF . "wtusrate (
		`id`  int(6) NOT NULL AUTO_INCREMENT ,
		`user_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
		`games_id`  text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
		PRIMARY KEY (`id`)
		)
		DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci
		;");

$result = mysql_query("SELECT * FROM " . WEBTOMAT_PREF . "wtmodule" );
while ( $row = $data->wt_getrow($result) ) {
	$$row['params'] = $row['val'];
}


?>